/*!
 * @file explosion.h
 * @brief a LightningBolt Projectile
*/

#ifndef _LIGHTNING_BOLT_H
#define _LIGHTNING_BOLT_H

#include "world_entity.h"

#include "sound_buffer.h"
#include "sound_source.h"

class Material;

class LightningBolt : public WorldEntity
{
  public:
    LightningBolt(const TiXmlElement* root = NULL);
    virtual ~LightningBolt ();

    virtual void activate();
    virtual void deactivate();

    virtual void tick(float time);
    virtual void draw() const;

  private:
    float flashFrequency;                   //!< frequency to activate itself
    float flashRisingTime;                  //!< time to rise
    float flashConstTime;                   //!< time to be drawn
    float flashFallTime;                    //!< time to fall

    float time;                             //!< time

    bool  bRender;
    bool  bNewCoordinate;
    Material*      material;
    Vector         offset;
    float width;
    float height;

    float seedX;
    float seedZ;
    float seedTime;

    SoundSource    soundSource;
    SoundBuffer*   thunderBuffer;
};

#endif /* _LIGHTNING_BOLT_H */
